module L = Lambda;;

let vf = 'f';;
let vl = 'l';;
let vm = 'm';;
let vn = 'n';;
let vp = 'p';;
let vx = 'x';;
let vy = 'y';;
let vz = 'z';;
let f = L.var vf;;
let l = L.var vl;;
let m = L.var vm;;
let n = L.var vn;;
let p = L.var vp;;
let x = L.var vx;;
let y = L.var vy;;
let z = L.var vz;;

let tid = L.abs [vx] x;;
let tzero = L.abs [vf; vx] x;;
let tone = L.abs [vf; vx] (L.app [f; x]);;
let ttrue = L.abs [vx; vy] x;;
let tfalse = L.abs [vx; vy] y;;
let tif = L.abs [vx; vy; vz] (L.app [x; y; z]);;
let tadd = L.abs [vm; vn; vf; vx] (L.app [m; f; L.app [n; f; x]]);;
let tmult = L.abs [vm; vn; vf] (L.app [m; L.app [n; f]]);;
let texp = L.abs [vm; vn] (L.app [n; m]);;
let tpair = L.abs [vx; vy; vf] (L.app [f; x; y]);;
let tfst = L.abs [vp] (L.app [p; ttrue]);;
let tsnd = L.abs [vp] (L.app [p; tfalse]);;
let tffstfst =
 L.abs [vp; vf] (
  L.app [tpair; L.app [f; L.app [tfst; p]]; L.app [tfst; p]]
 )
;;
let tpre =
 L.abs [vn; vf; vx] (
  L.app [tsnd; L.app [n; L.app [tffstfst; f]; L.app [tpair; x; x]]]
 )
;;
let tsub = L.abs [vm; vn] (L.app [n; tpre; m]);;
let tcons = L.abs [vx; vy] (L.app [tpair; tfalse; L.app [tpair; x; y]]);;
let thd = L.abs [vz] (L.app [tfst; L.app [tsnd; z]]);;
let ttl = L.abs [vz] (L.app [tsnd; L.app [tsnd; z]]);;
let tnil = tid;;
let tnull = tfst;;
let tY =
 L.abs [vf] (
  L.app [
   L.abs [vx] (L.app [f; L.app [x; x]]);
   L.abs [vx] (L.app [f; L.app [x; x]])
  ]
 )
;;
let tZ =
 L.abs [vf] (
  L.app [
   L.abs [vx] (L.app [f; L.app [x; x]]);
   L.abs [vx] (L.app [f; L.abs [vy] (L.app [x; x; y])]);
  ]
 )
;;
let tlengthn =
 L.app [
  tY; (
   L.abs [vf; vx] (
    L.app [
     tif; 
     L.app [tnull; x];
     tzero; 
     L.app [tadd; tone; L.app [f; L.app [ttl; x]]]
    ]
   )
  )
 ]
;;
let tlengthv =
 L.app [
  tZ; (
   L.abs [vf; vx] (
    L.app [
     L.app [
      tif; 
      L.app [tnull; x];
      L.abs [vz] tzero; 
      L.abs [vz] (L.app [tadd; tone; L.app [f; L.app [ttl; x]]])
     ];
     z
    ]
   )
  )
 ]
;;
let tsucc = L.abs [vn; vf; vx] (L.app [f; L.app [n; f; x]]);;
let tmapn =
 L.app [
  tY; (
   L.abs [vm; vf; vl] (
    L.app [
     tif;
     L.app [tnull; l];
     tnil;
     L.app [
      tcons;
      L.app [f; L.app [thd; l]];
      L.app [m; f; L.app [ttl; l]]
     ]
    ]
   )
  )
 ]
;;
